=== debian/changelog ===
geonkick (3.7.0-0ubuntu1) resolute; urgency=medium

  * New upstream release.
  * d/copyright: bump dates
  * d/control: bump Standards-Version, no changes required
  * Refreshed patch

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Fri, 02 Jan 2026 12:29:00 -0800
